﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace MenuItemSeparatorStyle
{
    public partial class Form1 : Form, IUIElementDrawFilter
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += Form1_Load;
        }

        void Form1_Load(object sender, EventArgs e)
        {
            this.ultraToolbarsManager1.DrawFilter = this;
        }

        //Create a pen that will be drawn on top of the existing SeparatorItemUIElement
        Pen pen = new Pen(Color.Black, 5);
        
        //Utilize DrawFilter to Draw the Pen
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            Rectangle elementRect = drawParams.Element.Rect;
            drawParams.Graphics.DrawLine(pen, elementRect.Location, new Point(elementRect.Right, elementRect.Top));

            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is PopupMenuSeparatorItemUIElement)
                return DrawPhase.AfterDrawElement;
            else
                return DrawPhase.None;
        }
    }
}
